--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


IM_Show_Stacked = 0;				--show stacked items in inventory window
IM_Show_Nill = 0;				--show empty value prices in inventory window
IM_Sort_Value = 0;				--sort by value in inventory window
IM_Sort_Rarity_INV = 0;				--sort by rarity in inventory window
local IMCHK_ITEMS_TOSHOW = 15;
local IMCHK_ITEMS_HEIGHT = 16;



---------------------------------------------------
-- IM_InvCHK_OnShow
---------------------------------------------------
function IM_InvCHK_OnShow()

	IM_InvCHK_Update();

end

---------------------------------------------------
-- IM_InvCHK_OnShow
---------------------------------------------------
function IM_InvCHK_OnHide()

	HideUIPanel(ItemsMatrix_Inv_Frame);
	PlaySound("igBackPackClose");
			
end


---------------------------------------------------
-- IM_InvCHK_Update
---------------------------------------------------
function IM_InvCHK_Update()

	IM_InvList = nil;
	
	local offset = FauxScrollFrame_GetOffset(ItemsMatrix_IC_ScrollFrame);
	
	if( offset ) then 	--we always want to do one less because, lets say that item is sold and that
					--offset is no longer available.
					
		FauxScrollFrame_SetOffset(ItemsMatrix_IC_ScrollFrame, offset);
		
		
	else
		FauxScrollFrame_SetOffset(ItemsMatrix_IC_ScrollFrame, 0);
	end
	
	IM_InvCHK_BuildDisplayIndices();
	IM_InvCHK_UpdateView();

end


---------------------------------------------------
-- IMInv_Click
---------------------------------------------------
function IMInv_Click(arg1)
local item;

	if(not IM_InvList) then return; end
	
	    local id = this:GetID();
	    
	    if(id == 0) then
	    	id = this:GetParent():GetID();
	    end
	    
	    local offset = FauxScrollFrame_GetOffset(ItemsMatrix_IC_ScrollFrame);
	    
	    if(IM_InvList[id + offset]) then
	    
	    	item = IM_InvList[id + offset];
	    
	    end

	if(not item) then return; end
		

	    if arg1 == "LeftButton" then
		if IsShiftKeyDown() then
		    if ChatFrameEditBox:IsVisible() then
			local link = GetContainerItemLink(item.bag, item.slot);
			if link then ChatFrameEditBox:Insert(link); end
		    end  -- editbox
		else
		    PickupContainerItem(item.bag, item.slot);
		end  -- shift down

	    elseif arg1 == "RightButton" then
		UseContainerItem(item.bag, item.slot);
	    end


end



---------------------------------------------------
-- IMInv_ItemButton_OnEnter
---------------------------------------------------
function IMInv_ItemButton_OnEnter()
local item;
 
	if(not IM_InvList) then return; end
	
	    local id = this:GetID();
	    
	    if(id == 0) then
	    	id = this:GetParent():GetID();
	    end
	    
	    local offset = FauxScrollFrame_GetOffset(ItemsMatrix_IC_ScrollFrame);
	    
	    if(IM_InvList[id + offset]) then
	    
	    	item = IM_InvList[id + offset];
	    
	    end
	    

	if(not item) then return; end
	

	-----------------------------------------------
	
	--only input if link is linkable
	if(item.name and IM_GetData(item.name, "item")) then


		--show appropriate cursors
		if(MerchantFrame:IsVisible() and not InRepairMode()) then

			ShowContainerSellCursor(item.bag, item.slot);

		elseif(MerchantFrame:IsVisible() and InRepairMode()) then

			--do nothing
		else
			ResetCursor();

		end

		
		--show tooltip
		IM_ShowItem(item.name,this,ItemsMatrix_Inv_Frame,item.count);


	end
				

	
	
	
	
	
	
end



---------------------------------------------------
-- IMInv_ItemButton_OnLeave
---------------------------------------------------
function IMInv_ItemButton_OnLeave()

	if( ItemsMatrix_Inv_Frame.TooltipButton ) then
		ItemsMatrix_Inv_Frame.TooltipButton = nil;
		HideUIPanel(GameTooltip);
	end

end


---------------------------------------------------
-- IM_InvCHK_BuildDisplayIndices
---------------------------------------------------
function IM_InvCHK_BuildDisplayIndices()

	IM_InvList =  nil; --empty it out
	
	IM_InvList = { }; -- populate it as an array

	local iNew = 1;

    	local costOfItem;
    	
    	local sColor;
    
    
    	if(IM_Show_Stacked == nil) then
    		IM_Show_Stacked = 0;
    	end
    	
    	if(IM_Show_Nill == nil) then
    		IM_Show_Nill = 0;
    	end
    	
    
    for bag=0,NUM_BAG_FRAMES do
      for slot=1,GetContainerNumSlots(bag) do
    
            local link = GetContainerItemLink(bag, slot);
            
            if (link and link ~= "") then
            
            
            	local name = ItemsMatrix_NameFromLink(link); --get the name
            	
            	if(name and name ~= "") then

			if(name and name ~= "") then

				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bag, slot);

				if(not IMDB) then
					return nil;
				end
				
				
				--MAKE SURE WE HAVE AN ITEMCOUNT!
				if(itemCount) then
				
					costOfItem = 0;

					if( name and IM_Realm and IMDB[IM_Realm] and IMDB[IM_Realm][name] and IM_GetData(name, "price")) then

						costOfItem = IM_GetData(name, "price");

					end


					if (costOfItem and IM_Show_Stacked == 1 and itemCount and itemCount > 0 )then

						  costOfItem = floor(tonumber(costOfItem) * tonumber(itemCount));
					end



					if(not costOfItem or costOfItem == 0 and IM_Show_Nill == 1) then
						--do nothing cause we want to hide value for this item

					else

						--insert into table
						IM_InvList[iNew] = { };
						IM_InvList[iNew].name = name;
						IM_InvList[iNew].money = costOfItem;
						IM_InvList[iNew].bag = bag;
						IM_InvList[iNew].slot = slot;
						IM_InvList[iNew].count = itemCount;
						IM_InvList[iNew].quality = quality;
						IM_InvList[iNew].texture = texture;

						iNew = iNew + 1;

					end
				
				end--if(itemCount) then
				
				
				
			end--if(name and name ~= "") then
			
                end--if(name and name ~= "") then

                
            end--if (link and link ~= "") then

            
            
        end--end for
    end--end for
    
    IM_InvList.onePastEnd = iNew;

  
  IM_InvCHK_Sort();
  
  
end


---------------------------------------------------
-- IM_InvCHK_Sort
---------------------------------------------------
function IM_InvCHK_Sort()

  if not IM_InvList then return; end
  
  	if(IM_Sort_Value == 1) then
  	
  		table.sort(IM_InvList, IM_InvCHK_SortByValue);
  		
  	elseif(IM_Sort_Rarity_INV == 1) then
  	
  		table.sort(IM_InvList, IM_InvCHK_ColorComparison);
  		
  	else
  		table.sort(IM_InvList, IM_InvCHK_SortByName);
  	
  	end

end


function IM_InvCHK_SortByName(a,b)

    return a.name < b.name;
    
end

function IM_InvCHK_SortByValue(a,b)

	if(a.money and b.money) then
		return b.money < a.money;
	end

end


function IM_InvCHK_ColorComparison(elem1, elem2)

	if(elem1.quality and elem2.quality) then
		return elem2.quality < elem1.quality;
	end

end


---------------------------------------------------
-- IM_InvCHK_UpdateView
---------------------------------------------------


function IM_InvCHK_UpdateView()

local iItem;
local invChk_item;

	if not ItemsMatrix_Inv_Frame:IsVisible() then return; end

	  if not IM_InvList then IM_InvCHK_BuildDisplayIndices(); end --make sure
	  
		FauxScrollFrame_Update(ItemsMatrix_IC_ScrollFrame, IM_InvList.onePastEnd - 1, IMCHK_ITEMS_TOSHOW, IMCHK_ITEMS_HEIGHT);
		
		for iItem = 1, IMCHK_ITEMS_TOSHOW, 1 do
		
			local itemIndex = iItem + FauxScrollFrame_GetOffset(ItemsMatrix_IC_ScrollFrame);
			local IMItemObj = getglobal("IM_BrowseButton"..iItem);
			
			if( itemIndex < IM_InvList.onePastEnd ) then
			

				if(IM_InvList[itemIndex]) then
				
					invChk_item = IM_InvList[itemIndex] ;
				
					--set name
					if(IM_InvList[itemIndex].name) then
						getglobal("IM_BrowseButton"..iItem.."Name"):SetText(IM_InvList[itemIndex].name);
					end
					
					--set color
					local color = { };
					if(invChk_item.quality) then
						color = ITEM_QUALITY_COLORS[tonumber(invChk_item.quality)];
						getglobal("IM_BrowseButton"..iItem.."Name"):SetTextColor(color.r, color.g, color.b);
						getglobal("IM_BrowseButton"..iItem.."Name").r = color.r;
						getglobal("IM_BrowseButton"..iItem.."Name").g = color.g;
						getglobal("IM_BrowseButton"..iItem.."Name").b = color.b;
					else
						getglobal("IM_BrowseButton"..iItem.."Name").r = 0;
						getglobal("IM_BrowseButton"..iItem.."Name").g = 0;
						getglobal("IM_BrowseButton"..iItem.."Name").b = 0;
					end

					
					local moneyFrame = getglobal("IM_BrowseButton"..iItem.."MoneyFrame");
					
					--set price if available
					if(invChk_item.money and moneyFrame) then
					
						MoneyFrame_Update(moneyFrame:GetName(), invChk_item.money);
						moneyFrame:Show();
					end

					
					--set texture
					if(invChk_item.texture) then
						getglobal("IM_BrowseButton"..iItem.."ItemIconTexture"):SetTexture(invChk_item.texture);
					end
					
					--show stacked items
					if(invChk_item.count > 1 and IM_Show_Stacked == 1) then
						getglobal("IM_BrowseButton"..iItem.."ItemCount"):SetText(invChk_item.count);
						getglobal("IM_BrowseButton"..iItem.."ItemCount"):Show();
						
					else
						getglobal("IM_BrowseButton"..iItem.."ItemCount"):Hide();
					end
					
					IMItemObj:Show();
					
				else
					IMItemObj:Hide();
					
				
				end
				
			else
				
				IMItemObj:Hide();
				
			
			end
			
		end --end for

end




--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------