--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


---------------------------------------------------
-- IM_ShowItem
---------------------------------------------------
function IM_ShowItem(sIM_Item, sObj, sFrame, sCount)
local color;
local storeCompress;
local doRegular = 0;
local storeLink;
local lines_added = 0;
local storeWidth = 0;

	--make sure we have objects to work with
	if(not sIM_Item or not sObj or not sFrame) then
		return nil;
	end

	--check IMDB
	if(not IMDB) then return nil; end
	
	--check for realm
	if(not IM_Realm) then return nil; end
	
	--check realm DB
	if(not IMDB[IM_Realm]) then return nil; end

	--check realm DB item
	if(not IMDB[IM_Realm][sIM_Item]) then 

		--ITEM NAME
		------------------------------------------------------------
		sFrame.TooltipButton = sObj:GetID();
		GameTooltip:SetOwner(sObj, "ANCHOR_RIGHT");
		
		--Add one line so we can edit the first line
		GameTooltip:AddLine(" ", 1, 1, 1);
		
		--show invalid
		GameTooltip:AddLine("Item was deleted!", 255/255, 0, 0);
		GameTooltip:AddLine("Item will be removed upon refresh.", 255/256, 128/255, 0);
		GameTooltip:AddLine("<Item is NOT Linkable>", 255/255, 0, 0);
		
		
		--GameTooltip
		GameTooltip.isDone = 1;
		
		
		--Show Tooltip
		GameTooltip:Show();
		
		return nil;
	end
		
		
	
	--make sure we aren't repeating things
	if(GameTooltip.isDone) then
		return nil;
	end


	--check to see if we can use the regular tooltip.
	--if not then use the custom one.
	if(IM_GetData(sIM_Item, "item")) then


		local nameGIF, linkGIF, qualityGIF, minLevelGIF, classGIF, subclassGIF, maxStackGIF = GetItemInfo(IM_GetData(sIM_Item, "item"));

		if(linkGIF and nameGIF) then

			doRegular = 1;
			
			storeLink = linkGIF;
		end



	end
	

	------------------------------------------
	-----  REGULAR TOOLTIP
	------------------------------------------
	
	if(GameTooltip and doRegular == 1) then
	

		--check to see if we have a link and that it is a linked pattern
		if( storeLink and ItemsMatrix_GetLinkPatternCount(storeLink) == 4) then
		

			sFrame.TooltipButton = sObj:GetID();
			GameTooltip:SetOwner(sObj, "ANCHOR_RIGHT");
			GameTooltip:SetHyperlink(storeLink);

			
			--if we have an itemcount then show it otherwise show itemcount of 1
			if(sCount) then
			
				--Update for other mods
				IM_UpdateOtherMods(GameTooltip, sIM_Item , sCount);


				if(IM_GetData(sIM_Item, "price")) then

					ItemsMatrix_AddTooltipMoney(sIM_Item,GameTooltip,sCount);
				
				elseif(IM_GetData(sIM_Item, "vendor")) then

					ItemsMatrix_AddTooltipMoney(sIM_Item,GameTooltip,1);
					
				end
				
				
				
			else
			
				--Update for other mods
				IM_UpdateOtherMods(GameTooltip, sIM_Item , 1);


				if(IM_GetData(sIM_Item, "price")) then


					ItemsMatrix_AddTooltipMoney(sIM_Item,GameTooltip,sCount);
					
				
				elseif(IM_GetData(sIM_Item, "vendor")) then

					ItemsMatrix_AddTooltipMoney(sIM_Item,GameTooltip,1);
					
				end
			
			end --end if(sCount) then
			
			
			--------------------------------------------------------------------
			--add an extra line before the stuff below
			lines_added = lines_added + 1;
			GameTooltip:AddLine(" ", 1, 1, 1);
			

			--show realm
			--if(IM_GetData(sIM_Item, "realm")) then

			--	lines_added = lines_added + 1;
			--	GameTooltip:AddLine("|c00FF3E4D["..IM_GetData(sIM_Item, "realm").."]|r", 1, 1, 1); --add the name not the value

			--end
				

			--show player (this is important)
			--if(IM_GetData(sIM_Item, "player")) then

			--	lines_added = lines_added + 1;
			--	GameTooltip:AddLine("|c004ECA00<Player: "..IM_GetData(sIM_Item, "player")..">|r", 1, 1, 1); --add the name not the value

			--end



			--show if linkable or not
			if(storeLink) then
				
				lines_added = lines_added + 1;
				GameTooltip:AddLine("<Item is Linkable>", 255/255, 255/255, 128/255);

			else
				lines_added = lines_added + 1;
				GameTooltip:AddLine("<Item is NOT Linkable>", 255/255, 0, 0);

			end
			--------------------------------------------------------------------

				

			--set the tooltip height
			GameTooltip:SetHeight(GameTooltip:GetHeight() + 14*lines_added);
			

			--now edit the width if it's really small
			if(GameTooltip:GetWidth() ~= nil and GameTooltip:GetWidth() < 140) then

				
				GameTooltip:SetWidth(140); --edit the tooltip width first
				

			end
			
			
			
			--GameTooltip
			GameTooltip.isDone = 1;
			
			--Show Tooltip
			GameTooltip:Show();
			

		end
	
	
	
		return nil;
	end



	------------------------------------------
	-----  CUSTOM TOOLTIP
	------------------------------------------
	if(GameTooltip and doRegular == 0) then


		--ITEM NAME
		------------------------------------------------------------
		sFrame.TooltipButton = sObj:GetID();
		GameTooltip:SetOwner(sObj, "ANCHOR_RIGHT");
		
		--Add one line so we can edit the first line
		GameTooltip:AddLine(" ", 1, 1, 1);
		
		--show invalid
		GameTooltip:AddLine("Invalid Item", 255/255, 0, 0);
		GameTooltip:AddLine("<Item is NOT Linkable>", 255/255, 0, 0);
		
		
		--GameTooltip
		GameTooltip.isDone = 1;
		
		
		--Show Tooltip
		GameTooltip:Show();
		
		
	
	end --end tooltip available check
	
	

	
end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------


